datablock fxLightData(HeadLight:PlayerLight) {
   className = "fxLightData";
   radius = 20;
   Brightness = 6;
   FlareOn=0;
   uiName = "";
};
datablock ShapeBaseImageData(mLightImage)
{
   shapefile = "base/data/shapes/empty.dts";
   mountpoint = 0;
   emap = 1;
   //eyeoffset = "20 0 0";
   offset = "20 0 0";
   lightType = "ConstantLight";
   lightColor = "1 1 1 1";
   lightTime = "99999999";
   lightRadius = "10";
};
if(isPackage(mVehicleLights))
   deactivatepackage(mVehicleLights);
package mVehicleLights
{
   function servercmdLight(%client)
   {
      if(!isObject(%player=%client.player))
         return Parent::ServercmdLight(%client);
      if(!isObject(%mount=%player.getObjectMount()))
         return Parent::servercmdLight(%client);
      if(%mount.lastDrivingClient!=%client)
         return Parent::servercmdLight(%client);
      if(%mount.getClassName()$="WheeledVehicle")
      {
         if(!isObject(%mount.mLight))
            %mount.mLightTick();
         else
            cancel(%mount.mLightSched);
         Parent::servercmdLight(%client);
         if(isOBject(%player.light))
            %player.light.delete();
      }
   }
};
activatepackage(mVehicleLights);

function WheeledVehicle::mLightTick(%obj)
{
   cancel(%obj.mLightSched);
   if(!isObject(%obj.getMountedObject(0)))
      return;
   if(!isObject(%obj.mLight))
      %obj.mLight = new FxLight()
      {
         datablock = HeadLight;
         position = %obj.mLightPos();
         enable=1;
         scale="1 1 1";
         rotation = 0;
         IconSize=0.1;
      };
   %obj.mLightMove();
   %obj.mLightSched=%obj.schedule(50,mLightTick);
}
function WheeledVehicle::mLightPos(%obj)
{
   %dist = getWord(%obj.scale,2)*20;
   %mask = ($Typemasks::PlayerObjectType | $TypeMasks::FxBrickObjectType | $TypeMasks::StaticObjectType | $Typemasks::VehicleObjectType);
   %start = vectorScale(vectorAdd(%obj.getPosition(),%obj.getWorldBoxCenter()),0.5);
   %vector = %obj.getEyeVector();
   %end = vectorAdd(%start,vectorScale(%vector,%dist));
   %ray = containerRayCast(%start,%end,%mask,%obj);
   %col=firstWord(%ray);
   %hit=posFromRaycast(%ray);
   if(isObject(%col))
      return vectorAdd(%start,vectorScale(%vector,vectorDist(%start,%hit)-0.5));
   return vectorAdd(%end,vectorScale(%obj.getVelocity(),0.3));
}
function WheeledVehicle::mLightMove(%obj)
{
   %goal = %obj.mLightPos();
   %light=%obj.mLight;
   %light.slide(%goal);
   cancel(%light.mDelSched);
   %light.mDelSched=%light.schedule(100,delete);
}
$mLightSpeed=0.45; // 1 = instant, 0 = not moving, 0.5 = half life
function fxLight::Slide(%obj,%goal)
{
   %pos = %obj.getPosition();
   %sub=vectorNormalize(vectorsub(%goal,%pos));
   %vector=vectorScale(%sub,vectorDist(%goal,%pos)*$mLightSpeed);
   %pos=vectorAdd(%vector,%pos);
   %obj.setTransform(%pos);
   %obj.reset();
}